var waveManager = waveManager || {};

waveManager.currentWave = function(){

	// check if the dummy is moving
	// if not, we'll select a starting location and process and path for it.
	if( !dummy.moving ){

		dummy.moving = true;
		dummy.path = getPath( cells );
		dummy.speed = 0.002;

		console.log( dummy );

		// we'll get the position for the dummy.
		var position = cells.list[ dummy.path[ 0 ] ].center.clone();
		dummy.position.set( position.x , position.y , position.z );

		// we're going to construct an incremental vector.  It'll be a normalized vector pointing in the 
		// direction of the next cell,  Then it's length will be divided by the dummy's speed.
		// then each iteration of the dummy's movement, we'll add the increment vector to it's position.
		var increment = cells.list[ dummy.path[1] ].center.clone();
		increment = increment.sub( position ).normalize();
		increment.multiplyScalar( dummy.speed );
		dummy.increment = increment.clone();

		// we'll record the next position
		dummy.next = 1;
		dummy.goal = cells.list[ dummy.path[1] ].center.clone();

		// and will determine the lookAt position
		//dummy.up = position.normalize();
		dummy.lookAt( cells.list[ dummy.path[ 1 ] ].center.clone() );
		
		dummy.visible = true;

	} else {

		// we'll move the dummy
		dummy.position.set( dummy.position.x + dummy.increment.x , dummy.position.y + dummy.increment.y , dummy.position.z + dummy.increment.z );

		// and rotate the dummy
		dummy.rotateY( 0.03 );

		// cycle through all viewable towers and orient their turrets toward the dummy
		for( var i=0, ii=towers.length; i<ii; i++ ){
			towers[ i ].turret.lookAt( dummy.position.clone() );
		}

		// now we'll test to see if the distance between the dummies position and it's goal is the almost zero
		if( dummy.position.distanceTo( dummy.goal ) < dummy.speed ){

			dummy.next ++;
			console.log( dummy.next );

			// now we'll test if we've come to the end.  If so we'll reset the dummy back to the beginning.
			if( dummy.next > dummy.path.length-1 ){

				// we'll get the position for the dummy.
				var position = cells.list[ dummy.path[ 0 ] ].center.clone();
				dummy.position.set( position.x , position.y , position.z );

				// we're going to construct an incremental vector.  It'll be a normalized vector pointing in the 
				// direction of the next cell,  Then it's length will be divided by the dummy's speed.
				// then each iteration of the dummy's movement, we'll add the increment vector to it's position.
				var increment = cells.list[ dummy.path[1] ].center.clone();
				increment = increment.sub( position ).normalize();
				increment.multiplyScalar( dummy.speed );
				dummy.increment = increment.clone();

				// we'll record the next position
				dummy.next = 1;
				dummy.goal = cells.list[ dummy.path[1] ].center.clone();

			} else {

				dummy.goal = cells.list[ dummy.path[ dummy.next ] ].center.clone();
				// we'll increment to the next position in the path.
				var position = dummy.position.clone();

				// we're going to construct an incremental vector.  It'll be a normalized vector pointing in the 
				// direction of the next cell,  Then it's length will be divided by the dummy's speed.
				// then each iteration of the dummy's movement, we'll add the increment vector to it's position.
				var increment = cells.list[ dummy.path[ dummy.next ] ].center.clone();
				increment = increment.sub( position ).normalize();
				increment.multiplyScalar( dummy.speed );
				dummy.increment = increment.clone();
			}

		}

	}


}

function getPath( cells ){

	var aCell;

	// set all currentIteration arrays to their travelTo state.
	for( var i=0, ii=cells.list.length; i<ii; i++ ){
		aCell = cells.list[ i ];
		for( var j=0; j<8; j++ ){
			aCell.currentIteration[ j ] = aCell.travelTo[ j ];
		}
	}

	// path will be an array that we add to.  At each iteration of our Flood Fill pathfinding algorithm
	// the path will copy its self for each subsequent iteration and add a unique bit to each new construct.  
	// Each Path item will contain an array of all spaces it has traveled to and begin with the overall distance.
	// Each enemy will spawn on a random startIndex cell contained in the cells.startIndexes array.
	// the first entry in the path array will be an object indicating whether or not an end goal has been found.
	// and what the indexed position is for the shortest path and the length of the shortest path.
	var randomStartingIndex =  cells.startingIndexes[ Math.floor( Math.random() * cells.startingIndexes.length ) ];
	console.log( randomStartingIndex );
	var path = [ { goal: false , index: -1, length: 10000 } , [ 0 , randomStartingIndex ] ];

	iterateThroughAllDirections( cells , path );

	// update the length of the path to reflect the actual length.
	path[ path[0].index ].splice( 0 , 1 );

	// we'll return the path which is the shortest, which is recorded in the index position
	return path[ path[0].index ];
}